function x=gaussp_kol(A,b),
% eliminacja Gaussa z wyborem elementu gwnego w kolumnie
  n=max(size(A));
  for i=1:n-1,
    [xx,p]=max(abs(A(i:n,i)));   % p - indeks max. elementu w i-tej kolumnie (liczc od i)
    if xx==0, x=inf; break; end,
    p=p+i-1;                     % p - indeks max. elementu w i-tej kolumnie (liczc od 1)
    if p~=i,
      xx=A(i,i:n); A(i,i:n)=A(p,i:n); A(p,i:n)=xx;   % zamiana biecego (i-tego) wiersza mac.A z wierszem p
      xxx=b(i); b(i)=b(p); b(p)=xxx;                 % jw. - w wektorze b
    end,
    for j=i+1:n,                                    % ptla algorytmu Gaussa
      m=A(j,i)/A(i,i);
      A(j,i+1:n)=A(j,i+1:n)-m.*A(i,i+1:n);
      b(j)=b(j)-m*b(i);
    end,
  end,
  x=zeros(n,1);                                     % rozwizanie trjktnego ukadu rwna (eliminacja wstecz)
  x(n)=b(n)/A(n,n);
  for i=n-1:-1:1, x(i)=(b(i)-A(i,:)*x)/A(i,i); end,

